/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.webapp.jonasadmin.service.resource;

import java.io.IOException;
import java.util.Iterator;

import javax.management.ObjectName;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.objectweb.jonas.jmx.JonasObjectName;
import org.objectweb.jonas.webapp.jonasadmin.JonasAdminException;
import org.objectweb.jonas.webapp.jonasadmin.JonasAdminJmx;
import org.objectweb.jonas.webapp.jonasadmin.JonasBaseAction;

/**
 * @author Michel-Ange ANTON
 */

public class EditRarAction extends JonasBaseAction {

// --------------------------------------------------------- Public Methods

    public ActionForward executeAction(ActionMapping p_Mapping, ActionForm p_Form
        , HttpServletRequest p_Request, HttpServletResponse p_Response)
        throws IOException, ServletException {

        // Selected RAR
        String sSelectedPath = p_Request.getParameter("path");

        String serverName = m_WhereAreYou.getCurrentJonasServerName();

        // Find resource adapter
        try {
            if (sSelectedPath != null) {
                ObjectName on;
                String sPath;
                String sName = null;
                boolean bFound = false;
                Iterator it = JonasAdminJmx.getListMbean(JonasObjectName.resourceAdapters(), serverName).
                    iterator();
                while ((it.hasNext() == true) && (bFound == false)) {
                    on = (ObjectName) it.next();
                    sPath = getStringAttribute(on, "Filename");
                    sName = getStringAttribute(on, "JndiName");
                    if (sSelectedPath.equals(sPath) == true) {
                        bFound = true;
                    }
                }
                if (bFound == true) {
                    p_Request.setAttribute("name", sName);
                }
                else {
                    throw new JonasAdminException("error.resourceadapter.notfound"
                        , m_Resources.getMessage("error.resourceadapter.notfound", sSelectedPath));
                }
            }
        }
        catch (Throwable t) {
            addGlobalError(t);
            saveErrors(p_Request, m_Errors);
            return (p_Mapping.findForward("Global Error"));
        }
        // Forward to the jsp.
        return (p_Mapping.findForward("ActionEditResourceAdapter"));
    }
}
